import * as i0 from '@angular/core';
import { forwardRef, EventEmitter, Component, ViewEncapsulation, HostBinding, Input, Output, Inject, NgModule } from '@angular/core';
import * as i2 from '@angular/forms';
import { NG_VALUE_ACCESSOR, FormsModule } from '@angular/forms';
import { Hacks, TimeUnits } from '@tangential/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i3 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i3$1 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i4 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import moment$1 from 'moment';
import * as i5 from '@angular/material/slide-toggle';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import * as i1$1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA } from '@angular/material/dialog';
import * as i3$2 from '@tangential/components';
import { TanjComponentsModule } from '@tangential/components';
import * as moment from 'moment/moment';
import * as i5$1 from '@angular/material/slider';
import { MatSliderModule } from '@angular/material/slider';

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_CHECKBOX_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => CheckboxWidgetComponent),
    multi: true
};
class CheckboxWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class CheckboxWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = false;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = false;
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new CheckboxWidgetChange(this, this.value));
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
CheckboxWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: CheckboxWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
CheckboxWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: CheckboxWidgetComponent, selector: "tanj-checkbox-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_CHECKBOX_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], ngImport: i0, template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-checkbox-widget-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-widget-input"
           layout="column"
           layout-align="start">
        <mat-checkbox flex
                     [disabled]="disabled"
                     [(ngModel)]="value"
                     (change)="handleValueChange(value)">
        </mat-checkbox>
      </div>
      <div *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</div>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-checkbox-widget-label">{{label}}</span>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex"], exportAs: ["matCheckbox"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: CheckboxWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-checkbox-widget',
                    template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-checkbox-widget-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-widget-input"
           layout="column"
           layout-align="start">
        <mat-checkbox flex
                     [disabled]="disabled"
                     [(ngModel)]="value"
                     (change)="handleValueChange(value)">
        </mat-checkbox>
      </div>
      <div *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</div>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-checkbox-widget-label">{{label}}</span>
  </div>
                 `,
                    providers: [TANJ_CHECKBOX_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_CHECKBOX_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => CheckboxWidgetConfigureComponent),
    multi: true
};
class CheckboxWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class CheckboxWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = false;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.labelChange = new EventEmitter(false);
        this.defaultValue = false;
        this.defaultValueChange = new EventEmitter(false);
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    emitChangeEvent(value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new CheckboxWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
CheckboxWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: CheckboxWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
CheckboxWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: CheckboxWidgetConfigureComponent, selector: "tanj-checkbox-widget-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_CHECKBOX_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], ngImport: i0, template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="emitChangeEvent(false, true)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-checkbox-widget [(value)]="defaultValue"
                           (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                           [defaultValue]="defaultValue"
                           label="Default Value"
                           [labelPosition]="'before'">

      </tanj-checkbox-widget>
    </ng-container>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: CheckboxWidgetComponent, selector: "tanj-checkbox-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: CheckboxWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-checkbox-widget-configure',
                    template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="emitChangeEvent(false, true)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-checkbox-widget [(value)]="defaultValue"
                           (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                           [defaultValue]="defaultValue"
                           label="Default Value"
                           [labelPosition]="'before'">

      </tanj-checkbox-widget>
    </ng-container>
  </div>
                 `,
                    providers: [TANJ_CHECKBOX_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValue: [{
                type: Input
            }], defaultValueChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_DATE_TIME_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(() => DateTimeWidgetComponent), multi: true
};
class DateTimeWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class DateTimeWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = Date.now();
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultToNow = false;
        this.defaultValue = 0;
        this.maxLength = 100;
        this.minLength = 0;
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        this.onTouched = () => {
        };
        this.controlValueAccessorChangeFn = (value) => {
        };
    }
    ngOnInit() {
        this.value = this.defaultToNow ? Date.now() : this.defaultValue;
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    get dateInputValue() {
        return moment$1(this.value).format('YYYY-MM-DDTHH:mm:ss');
    }
    set dateInputValue(dateString) {
        this.value = moment$1(dateString).valueOf();
    }
    ngOnChanges(changes) {
        if (changes.defaultToNow && !this.value) {
            this.value = this.defaultToNow ? Date.now() : this.defaultValue;
        }
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    emitChangeEvent() {
        const change = new DateTimeWidgetChange(this, this.value);
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(change);
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
DateTimeWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DateTimeWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
DateTimeWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: DateTimeWidgetComponent, selector: "tanj-date-time-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultToNow: "defaultToNow", defaultValue: "defaultValue", maxLength: "maxLength", minLength: "minLength" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_DATE_TIME_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center">
    <span *ngIf="!hideLabel && labelPosition == 'before'" class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="center start">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-form-field flex
                            class="tanj-date-time-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="datetime-local"
                 minlength="{{minLength}}"
                 maxlength="{{maxLength}}"
                 [disabled]="disabled"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="dateInputValue"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
            `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DateTimeWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-date-time-widget', template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center">
    <span *ngIf="!hideLabel && labelPosition == 'before'" class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="center start">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-form-field flex
                            class="tanj-date-time-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="datetime-local"
                 minlength="{{minLength}}"
                 maxlength="{{maxLength}}"
                 [disabled]="disabled"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="dateInputValue"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
            `, providers: [TANJ_DATE_TIME_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultToNow: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], maxLength: [{
                type: Input
            }], minLength: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_DATE_TIME_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => DateTimeWidgetConfigureComponent),
    multi: true
};
class DateTimeWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class DateTimeWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.labelChange = new EventEmitter(false);
        this.defaultValue = Date.now();
        this.defaultValueChange = new EventEmitter(false);
        this.defaultToNow = false;
        this.defaultToNowChange = new EventEmitter(false);
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    emitChangeEvent(value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new DateTimeWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
DateTimeWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DateTimeWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
DateTimeWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: DateTimeWidgetConfigureComponent, selector: "tanj-date-time-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", defaultToNow: "defaultToNow" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", defaultToNowChange: "defaultToNowChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_DATE_TIME_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <mat-slide-toggle class="tanj-input" [labelPosition]="'before'" [(ngModel)]="defaultToNow">Default to current time?
      </mat-slide-toggle>
      <tanj-date-time-widget *ngIf="!defaultToNow" [(value)]="defaultValue"
                            (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                            [defaultValue]="defaultValue"
                            label="Default Value"></tanj-date-time-widget>
    </ng-container>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i5.MatSlideToggle, selector: "mat-slide-toggle", inputs: ["disabled", "disableRipple", "color", "tabIndex"], exportAs: ["matSlideToggle"] }, { kind: "component", type: DateTimeWidgetComponent, selector: "tanj-date-time-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultToNow", "defaultValue", "maxLength", "minLength"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DateTimeWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-date-time-configure',
                    template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <mat-slide-toggle class="tanj-input" [labelPosition]="'before'" [(ngModel)]="defaultToNow">Default to current time?
      </mat-slide-toggle>
      <tanj-date-time-widget *ngIf="!defaultToNow" [(value)]="defaultValue"
                            (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                            [defaultValue]="defaultValue"
                            label="Default Value"></tanj-date-time-widget>
    </ng-container>
  </div>
                 `,
                    providers: [TANJ_DATE_TIME_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValue: [{
                type: Input
            }], defaultValueChange: [{
                type: Output
            }], defaultToNow: [{
                type: Input
            }], defaultToNowChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_NUMBER_SPINNER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => NumberSpinnerWidgetComponent),
    multi: true
};
class NumberSpinnerWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class NumberSpinnerWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 10;
        this.min = 0;
        this.step = 1;
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        this.keyboardInputToggled = false;
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    onPreviousValueRequest() {
        if (!this.disabled) {
            const v = this.previousValue();
            if (v !== null) {
                this.handleValueChange(v);
            }
        }
    }
    onNextValueRequest() {
        if (!this.disabled) {
            const v = this.nextValue();
            if (v !== null) {
                this.handleValueChange(v);
            }
        }
    }
    nextValue() {
        let v = this.value + this.step;
        if (v > this.max) {
            v = this.max;
        }
        return v;
    }
    previousValue() {
        let v = this.value - this.step;
        if (v < this.min) {
            v = this.min;
        }
        return v;
    }
    swipeUp(event) {
        this.onNextValueRequest();
    }
    swipeDown(event) {
        this.onPreviousValueRequest();
    }
    onKeyboardInputRequest(event) {
        this.keyboardInputToggled = this.disabled ? false : !this.keyboardInputToggled;
    }
    /**
     * Boilerplate / required for Angular
     */
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new NumberSpinnerWidgetChange(this, this.value));
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
NumberSpinnerWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberSpinnerWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
NumberSpinnerWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: NumberSpinnerWidgetComponent, selector: "tanj-number-spinner-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", max: "max", min: "min", step: "step" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_NUMBER_SPINNER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div flex
       class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row" layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'" class="tanj-label tanj-before  tanj-number-spinner-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-input-spinner-field"
           layout="column"
           layout-align="start"
           (swipeUp)="swipeUp($event)"
           (swipeDown)="swipeDown($event)">
        <tanj-icon align="center"
                   font="material-icons"
                   ligature="arrow_drop_up"
                   (click)="$event.stopPropagation(); $event.preventDefault(); onNextValueRequest()"></tanj-icon>
        <div class="tanj-spinner-value tanj-previous ">{{previousValue() | number:'1.0-0'}}</div>
        <div *ngIf="!keyboardInputToggled"
             class="tanj-spinner-value tanj-current"
             (click)="onKeyboardInputRequest($event)">{{value | number:'1.0-0'}}
        </div>
        <input *ngIf="keyboardInputToggled"
               class="tanj-spinner-value tanj-current tanj-spinner-keyboard-input-toggled tanj-raw-input tanj-number"
               type="number"
               min="{{min}}"
               max="{{max}}"
               step="{{step}}"
               [(ngModel)]="value"
               autofocus
               (blur)="keyboardInputToggled = false">
        <div class="tanj-spinner-value tanj-next">{{nextValue() | number:'1.0-0'}}</div>
        <tanj-icon align="center"
                   font="material-icons"
                   ligature="arrow_drop_down"
                   (click)="$event.stopPropagation(); $event.preventDefault(); onPreviousValueRequest()"></tanj-icon>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below  tanj-number-spinner-label">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'"
          class="tanj-label tanj-after  tanj-number-spinner-label">{{label}}</span>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MinValidator, selector: "input[type=number][min][formControlName],input[type=number][min][formControl],input[type=number][min][ngModel]", inputs: ["min"] }, { kind: "directive", type: i2.MaxValidator, selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$2.IconComponent, selector: "tanj-icon", inputs: ["icon", "align", "font", "ligature", "disabled", "label"], outputs: ["click"] }, { kind: "pipe", type: i1.DecimalPipe, name: "number" }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberSpinnerWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-number-spinner-widget',
                    template: `<!-- -->
  <div flex
       class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row" layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'" class="tanj-label tanj-before  tanj-number-spinner-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-input-spinner-field"
           layout="column"
           layout-align="start"
           (swipeUp)="swipeUp($event)"
           (swipeDown)="swipeDown($event)">
        <tanj-icon align="center"
                   font="material-icons"
                   ligature="arrow_drop_up"
                   (click)="$event.stopPropagation(); $event.preventDefault(); onNextValueRequest()"></tanj-icon>
        <div class="tanj-spinner-value tanj-previous ">{{previousValue() | number:'1.0-0'}}</div>
        <div *ngIf="!keyboardInputToggled"
             class="tanj-spinner-value tanj-current"
             (click)="onKeyboardInputRequest($event)">{{value | number:'1.0-0'}}
        </div>
        <input *ngIf="keyboardInputToggled"
               class="tanj-spinner-value tanj-current tanj-spinner-keyboard-input-toggled tanj-raw-input tanj-number"
               type="number"
               min="{{min}}"
               max="{{max}}"
               step="{{step}}"
               [(ngModel)]="value"
               autofocus
               (blur)="keyboardInputToggled = false">
        <div class="tanj-spinner-value tanj-next">{{nextValue() | number:'1.0-0'}}</div>
        <tanj-icon align="center"
                   font="material-icons"
                   ligature="arrow_drop_down"
                   (click)="$event.stopPropagation(); $event.preventDefault(); onPreviousValueRequest()"></tanj-icon>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below  tanj-number-spinner-label">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'"
          class="tanj-label tanj-after  tanj-number-spinner-label">{{label}}</span>
  </div>
                 `,
                    providers: [TANJ_NUMBER_SPINNER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], min: [{
                type: Input
            }], step: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

class DurationPickerDialogResult {
    constructor() {
        this.success = false;
        this.millis = 0;
    }
}
class DurationPickerDialog {
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.result = new DurationPickerDialogResult();
        this.state = data.state;
    }
    onValueChange(field) {
        console.log('DurationPickerDialog', 'onValueChange', field);
    }
    onCancelRequest() {
        this.dialogRef.close(this.result);
    }
    onOkRequest() {
        this.result.success = true;
        this.result.millis = this.state.millis;
        this.dialogRef.close(this.result);
    }
}
DurationPickerDialog.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DurationPickerDialog, deps: [{ token: i1$1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
DurationPickerDialog.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: DurationPickerDialog, selector: "duration-picker-dialog", host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, ngImport: i0, template: "<div flex class=\"tanj-duration-picker-dialog-body\" layout=\"column\" layout-align=\"start\">\n  <div flex class=\"\" layout=\"row\" layout-align=\"space-around\">\n\n    <tanj-number-spinner-widget flex *ngFor=\"let field of state.selectedFields()\"\n                               [(ngModel)]=\"field.value\"\n                               [label]=\"field.label\"\n                               [labelPosition]=\"'below'\"\n                               [max]=\"field.max\"\n                               [min]=\"0\"\n                               (change)=\"onValueChange(field)\"></tanj-number-spinner-widget>\n  </div>\n</div>\n<div layout=\"column\" layout-align=\"end\">\n  <div flex class='tanj-button-footer' layout=\"row\" layout-align=\"center\">\n    <a flex mat-raised-button color=\"accent\" class=\"tanj-cancel\" (click)=\"onCancelRequest()\">Cancel</a>\n    <a flex mat-raised-button color=\"primary\" class=\"tanj-ok\" (click)=\"onOkRequest()\">Set</a>\n  </div>\n</div>\n\n", dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: NumberSpinnerWidgetComponent, selector: "tanj-number-spinner-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue", "max", "min", "step"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DurationPickerDialog, decorators: [{
            type: Component,
            args: [{ selector: 'duration-picker-dialog', encapsulation: ViewEncapsulation.None, template: "<div flex class=\"tanj-duration-picker-dialog-body\" layout=\"column\" layout-align=\"start\">\n  <div flex class=\"\" layout=\"row\" layout-align=\"space-around\">\n\n    <tanj-number-spinner-widget flex *ngFor=\"let field of state.selectedFields()\"\n                               [(ngModel)]=\"field.value\"\n                               [label]=\"field.label\"\n                               [labelPosition]=\"'below'\"\n                               [max]=\"field.max\"\n                               [min]=\"0\"\n                               (change)=\"onValueChange(field)\"></tanj-number-spinner-widget>\n  </div>\n</div>\n<div layout=\"column\" layout-align=\"end\">\n  <div flex class='tanj-button-footer' layout=\"row\" layout-align=\"center\">\n    <a flex mat-raised-button color=\"accent\" class=\"tanj-cancel\" (click)=\"onCancelRequest()\">Cancel</a>\n    <a flex mat-raised-button color=\"primary\" class=\"tanj-ok\" (click)=\"onOkRequest()\">Set</a>\n  </div>\n</div>\n\n" }]
        }], ctorParameters: function () { return [{ type: i1$1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }] } });

class DurationPickerFieldsState {
    constructor(picker, unit) {
        this.picker = picker;
        this.index = 0;
        this.unit = TimeUnits.h;
        this.selected = false;
        this.unit = unit;
        this.selected = false;
    }
    get label() {
        return this.unit.label;
    }
    canSelect() {
        let can;
        const count = this.picker.selectedCount();
        if (count >= 3) {
            can = false;
        }
        else if (count === 0) {
            can = true;
        }
        else {
            can = this.previous?.selected || this.next?.selected || false;
        }
        return can;
    }
    canDeselect() {
        /* If next and previous are selected then you cannot deselect this one. */
        return (!this.previous || !this.next || !this.previous.selected || !this.next.selected);
    }
    canToggleSelection() {
        return this.selected ? this.canDeselect() : this.canSelect();
    }
    get value() {
        let result;
        if (this.previous && this.previous.selected) {
            result = this.picker.duration.get(this.unit.momentKey);
        }
        else {
            result = this.picker.duration.as(this.unit.momentKey);
        }
        return Math.floor(result);
    }
    set value(val) {
        if (val >= 0) {
            const prev = this.value;
            this.picker.duration.add(val - prev, this.unit.momentKey);
        }
    }
    get separator() {
        return this.unit.separatorSuffix;
    }
    get max() {
        return (this.previous && this.previous.selected) ? this.unit.logicalMax : 9999;
    }
}
/** @todo: ggranum: Remove use of MomentJS if possible. */
class DurationPickerState {
    constructor() {
        this.fields = [];
        this.fieldsByKey = {};
        this.duration = moment.duration(0);
        this.max = 100;
        this.fields = [
            new DurationPickerFieldsState(this, TimeUnits.day), new DurationPickerFieldsState(this, TimeUnits.h),
            new DurationPickerFieldsState(this, TimeUnits.min), new DurationPickerFieldsState(this, TimeUnits.s),
            new DurationPickerFieldsState(this, TimeUnits.ms),
        ];
        for (let i = 0; i < this.fields.length; i++) {
            const f = this.fields[i];
            f.next = this.fields[i + 1];
            f.previous = this.fields[i - 1];
            f.index = i;
            this.fieldsByKey[f.unit.unitKey] = f;
        }
    }
    selectedFields() {
        return this.fields.filter(f => f.selected);
    }
    selectedCount() {
        return this.selectedFields().length;
    }
    setDuration(duration) {
        this.duration = duration;
    }
    select(unit) {
        this.fieldsByKey[unit.unitKey].selected = true;
    }
    get millis() {
        return this.duration.asMilliseconds();
    }
}

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => DurationPickerWidgetComponent),
    multi: true
};
class DurationPickerWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class DurationPickerWidgetComponent {
    constructor(changeDetectorRef, dialog) {
        this.changeDetectorRef = changeDetectorRef;
        this.dialog = dialog;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        /* end Configuration Fields */
        this.max = 10;
        this.showDays = false;
        this.showHours = false;
        this.showMinutes = false;
        this.showSeconds = false;
        this.showMilliseconds = false;
        this.change = new EventEmitter(false);
        this.state = new DurationPickerState();
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
        if (changes.value) {
            this.state.setDuration(moment$1.duration(this.value));
        }
        this.updateFields();
    }
    updateFields() {
        if (this.showDays) {
            this.state.select(TimeUnits.day);
        }
        if (this.showHours) {
            this.state.select(TimeUnits.h);
        }
        if (this.showMinutes) {
            this.state.select(TimeUnits.min);
        }
        if (this.showSeconds) {
            this.state.select(TimeUnits.s);
        }
        if (this.showMilliseconds) {
            this.state.select(TimeUnits.ms);
        }
    }
    showEditDialog() {
        const dialogRef = this.dialog.open(DurationPickerDialog, {
            disableClose: true,
            data: { state: this.state }
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (result.success) {
                this.value = result.millis;
                this.changeDetectorRef.detectChanges();
                this.emitChangeEvent();
            }
        });
    }
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new DurationPickerWidgetChange(this, this.value));
        this.valueChange.emit(this.value);
        console.log('DurationPickerWidgetComponent', 'emitChangeEvent');
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
DurationPickerWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DurationPickerWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.MatDialog }], target: i0.ɵɵFactoryTarget.Component });
DurationPickerWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: DurationPickerWidgetComponent, selector: "tanj-duration-picker-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", max: "max", showDays: "showDays", showHours: "showHours", showMinutes: "showMinutes", showSeconds: "showSeconds", showMilliseconds: "showMilliseconds" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div flex
       class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center"
       (click)="showEditDialog()">
      <span *ngIf="!hideLabel && labelPosition == 'before'"
            class="tanj-label tanj-icon-rating-widget-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-widget-input"
           layout="row"
           layout-align="start">

        <ng-container *ngFor="let field of state.fields">
          <span *ngIf="field.selected">{{field.value | number:'2.0-0'}}<span
            *ngIf="field.next?.selected">{{field.separator || ':'}}</span></span>
        </ng-container>

      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after tanj-icon-rating-widget-label">{{label}}</span>
  </div>

                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: i1.DecimalPipe, name: "number" }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DurationPickerWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-duration-picker-widget',
                    template: `<!-- -->
  <div flex
       class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center"
       (click)="showEditDialog()">
      <span *ngIf="!hideLabel && labelPosition == 'before'"
            class="tanj-label tanj-icon-rating-widget-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-widget-input"
           layout="row"
           layout-align="start">

        <ng-container *ngFor="let field of state.fields">
          <span *ngIf="field.selected">{{field.value | number:'2.0-0'}}<span
            *ngIf="field.next?.selected">{{field.separator || ':'}}</span></span>
        </ng-container>

      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after tanj-icon-rating-widget-label">{{label}}</span>
  </div>

                 `,
                    providers: [TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.MatDialog }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], showDays: [{
                type: Input
            }], showHours: [{
                type: Input
            }], showMinutes: [{
                type: Input
            }], showSeconds: [{
                type: Input
            }], showMilliseconds: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows IconRatingWidget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => DurationPickerWidgetConfigureComponent),
    multi: true
};
class DurationPickerWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class DurationPickerWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.labelChange = new EventEmitter(false);
        this.defaultValue = 0;
        this.defaultValueChange = new EventEmitter(false);
        this.max = 100;
        this.maxChange = new EventEmitter(false);
        this.showDays = false;
        this.showDaysChange = new EventEmitter(false);
        this.showHours = false;
        this.showHoursChange = new EventEmitter(false);
        this.showMinutes = false;
        this.showMinutesChange = new EventEmitter(false);
        this.showSeconds = false;
        this.showSecondsChange = new EventEmitter(false);
        this.showMilliseconds = false;
        this.showMillisecondsChange = new EventEmitter(false);
        /* end Configuration Fields */
        this.state = new DurationPickerState();
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
        if (changes.value) {
            this.state.setDuration(moment$1.duration(this.value));
        }
        this.updateFields();
    }
    updateFields() {
        if (this.showDays) {
            this.state.select(TimeUnits.day);
        }
        if (this.showHours) {
            this.state.select(TimeUnits.h);
        }
        if (this.showMinutes) {
            this.state.select(TimeUnits.min);
        }
        if (this.showSeconds) {
            this.state.select(TimeUnits.s);
        }
        if (this.showMilliseconds) {
            this.state.select(TimeUnits.ms);
        }
    }
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new DurationPickerWidgetConfigureChange(this, this.value));
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
DurationPickerWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DurationPickerWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
DurationPickerWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: DurationPickerWidgetConfigureComponent, selector: "tanj-duration-picker-widget-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", max: "max", showDays: "showDays", showHours: "showHours", showMinutes: "showMinutes", showSeconds: "showSeconds", showMilliseconds: "showMilliseconds" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", maxChange: "maxChange", showDaysChange: "showDaysChange", showHoursChange: "showHoursChange", showMinutesChange: "showMinutesChange", showSecondsChange: "showSecondsChange", showMillisecondsChange: "showMillisecondsChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!--  -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput
             class="tanj-input"
             type="text"
             maxlength="50"
             placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>

    <ng-container *ngIf="label">
      <fieldset flex layout="row" layout-align="start">
        <legend>For:</legend>
        <div flex class="tanj-choose-duration-fields-container" layout="column" layout-align="start">
          <mat-checkbox *ngFor="let field of state.fields"
                       layout="row" layout-align="start"
                       [disabled]="!field.canToggleSelection()"
                       [labelPosition]="'before'"
                       [checked]="field.selected"
                       (change)="field.selected = $event.checked">
            {{field.unit.fullLabel}}
          </mat-checkbox>
        </div>
      </fieldset>

      <tanj-duration-picker-widget
        [(value)]="defaultValue"
        (valueChange)="value = defaultValue; valueChange.emit(value); defaultValueChange.emit(defaultValue)"
        [defaultValue]="defaultValue"
        [showDays]="showDays"
        [showHours]="showHours"
        [showMinutes]="showMinutes"
        [showSeconds]="showSeconds"
        [showMilliseconds]="showMilliseconds"
        [max]="max"
        label="Default Value"
        [labelPosition]="'before'">
      </tanj-duration-picker-widget>
    </ng-container>

  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i3.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex"], exportAs: ["matCheckbox"] }, { kind: "component", type: DurationPickerWidgetComponent, selector: "tanj-duration-picker-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue", "max", "showDays", "showHours", "showMinutes", "showSeconds", "showMilliseconds"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: DurationPickerWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-duration-picker-widget-configure',
                    template: `<!--  -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput
             class="tanj-input"
             type="text"
             maxlength="50"
             placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>

    <ng-container *ngIf="label">
      <fieldset flex layout="row" layout-align="start">
        <legend>For:</legend>
        <div flex class="tanj-choose-duration-fields-container" layout="column" layout-align="start">
          <mat-checkbox *ngFor="let field of state.fields"
                       layout="row" layout-align="start"
                       [disabled]="!field.canToggleSelection()"
                       [labelPosition]="'before'"
                       [checked]="field.selected"
                       (change)="field.selected = $event.checked">
            {{field.unit.fullLabel}}
          </mat-checkbox>
        </div>
      </fieldset>

      <tanj-duration-picker-widget
        [(value)]="defaultValue"
        (valueChange)="value = defaultValue; valueChange.emit(value); defaultValueChange.emit(defaultValue)"
        [defaultValue]="defaultValue"
        [showDays]="showDays"
        [showHours]="showHours"
        [showMinutes]="showMinutes"
        [showSeconds]="showSeconds"
        [showMilliseconds]="showMilliseconds"
        [max]="max"
        label="Default Value"
        [labelPosition]="'before'">
      </tanj-duration-picker-widget>
    </ng-container>

  </div>
                 `,
                    providers: [TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValue: [{
                type: Input
            }], defaultValueChange: [{
                type: Output
            }], max: [{
                type: Input
            }], maxChange: [{
                type: Output
            }], showDays: [{
                type: Input
            }], showDaysChange: [{
                type: Output
            }], showHours: [{
                type: Input
            }], showHoursChange: [{
                type: Output
            }], showMinutes: [{
                type: Input
            }], showMinutesChange: [{
                type: Output
            }], showSeconds: [{
                type: Input
            }], showSecondsChange: [{
                type: Output
            }], showMilliseconds: [{
                type: Input
            }], showMillisecondsChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => IconRatingWidgetComponent),
    multi: true
};
class IconRatingWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class IconRatingWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.offIconNames = [];
        this.onIconNames = [];
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        this.icons = [];
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
        if (this.max && this.iconFont && this.offIconNames && this.onIconNames) {
            this.icons = [];
            for (let i = 0; i < this.max; i++) {
                const icon = {
                    font: this.iconFont,
                    name: i <= this.value ? this.onIconNames[0] : this.offIconNames[0]
                    //                           star                 star_border
                };
                this.icons.push(icon);
            }
        }
    }
    onIconClick(idx) {
        if (!this.disabled) {
            this.value = idx;
            this.valueChange.emit(this.value);
        }
    }
    swipeRight(event) {
    }
    swipeLeft(event) {
    }
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new IconRatingWidgetChange(this, this.value));
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
IconRatingWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: IconRatingWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
IconRatingWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: IconRatingWidgetComponent, selector: "tanj-icon-rating-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", max: "max", iconFont: "iconFont", offIconNames: "offIconNames", onIconNames: "onIconNames" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div flex
       class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-icon-rating-widget-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-icon-rating-stars tanj-widget-input"
           layout="column"
           layout-align="start"
           (swipeRight)="swipeRight($event)"
           (swipeLeft)="swipeLeft($event)">

        <div flex class="tanj-icon-rating-icons-container" layout="row" layout-align="start">
          <tanj-icon *ngFor="let icon of icons; let idx = index" [icon]="icon" (click)="onIconClick(idx)"></tanj-icon>
        </div>

      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after tanj-icon-rating-widget-label">{{label}}</span>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i3$2.IconComponent, selector: "tanj-icon", inputs: ["icon", "align", "font", "ligature", "disabled", "label"], outputs: ["click"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: IconRatingWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-icon-rating-widget',
                    template: `<!-- -->
  <div flex
       class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-icon-rating-widget-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-icon-rating-stars tanj-widget-input"
           layout="column"
           layout-align="start"
           (swipeRight)="swipeRight($event)"
           (swipeLeft)="swipeLeft($event)">

        <div flex class="tanj-icon-rating-icons-container" layout="row" layout-align="start">
          <tanj-icon *ngFor="let icon of icons; let idx = index" [icon]="icon" (click)="onIconClick(idx)"></tanj-icon>
        </div>

      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after tanj-icon-rating-widget-label">{{label}}</span>
  </div>
                 `,
                    providers: [TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], iconFont: [{
                type: Input
            }], offIconNames: [{
                type: Input
            }], onIconNames: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows IconRatingWidget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => IconRatingWidgetConfigureComponent),
    multi: true
};
class IconRatingWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class IconRatingWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.offIconNames = [];
        this.onIconNames = [];
        this.labelChange = new EventEmitter(false);
        this.defaultValueChange = new EventEmitter(false);
        this.maxChange = new EventEmitter(false);
        this.iconFontChange = new EventEmitter(false);
        this.offIconNamesChange = new EventEmitter(false);
        this.onIconNamesChange = new EventEmitter(false);
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new IconRatingWidgetConfigureChange(this, this.value));
    }
    swipeRight(event) {
    }
    swipeLeft(event) {
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
IconRatingWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: IconRatingWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
IconRatingWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: IconRatingWidgetConfigureComponent, selector: "tanj-icon-rating-widget-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", max: "max", iconFont: "iconFont", offIconNames: "offIconNames", onIconNames: "onIconNames" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", maxChange: "maxChange", iconFontChange: "iconFontChange", offIconNamesChange: "offIconNamesChange", onIconNamesChange: "onIconNamesChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], ngImport: i0, template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput
             class="tanj-input"
             type="text"
             maxlength="50"
             placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-icon-rating-widget
        [(value)]="defaultValue"
        (valueChange)="value = defaultValue; valueChange.emit(value); defaultValueChange.emit(defaultValue)"
        [defaultValue]="defaultValue"
        [max]="max"
        [iconFont]="iconFont"
        [offIconNames]="offIconNames"
        [onIconNames]="onIconNames"
        label="Default Value"
        [labelPosition]="'before'">

      </tanj-icon-rating-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max Rating"
               max="10"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
    </ng-container>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.MaxValidator, selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: IconRatingWidgetComponent, selector: "tanj-icon-rating-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue", "max", "iconFont", "offIconNames", "onIconNames"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: IconRatingWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-icon-rating-widget-configure',
                    template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput
             class="tanj-input"
             type="text"
             maxlength="50"
             placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-icon-rating-widget
        [(value)]="defaultValue"
        (valueChange)="value = defaultValue; valueChange.emit(value); defaultValueChange.emit(defaultValue)"
        [defaultValue]="defaultValue"
        [max]="max"
        [iconFont]="iconFont"
        [offIconNames]="offIconNames"
        [onIconNames]="onIconNames"
        label="Default Value"
        [labelPosition]="'before'">

      </tanj-icon-rating-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max Rating"
               max="10"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
    </ng-container>
  </div>
                 `,
                    providers: [TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], iconFont: [{
                type: Input
            }], offIconNames: [{
                type: Input
            }], onIconNames: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValueChange: [{
                type: Output
            }], maxChange: [{
                type: Output
            }], iconFontChange: [{
                type: Output
            }], offIconNamesChange: [{
                type: Output
            }], onIconNamesChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(() => NumberSliderWidgetComponent), multi: true
};
class NumberSliderWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class NumberSliderWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'below';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.min = 0;
        this.step = 1;
        this.decimalPlaces = 1;
        this.tickInterval = 1;
        this.vertical = false;
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        this.onTouched = () => {
        };
        this.controlValueAccessorChangeFn = (value) => {
        };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    emitChangeEvent() {
        const change = new NumberSliderWidgetChange(this, this.value);
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(change);
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
NumberSliderWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberSliderWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
NumberSliderWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: NumberSliderWidgetComponent, selector: "tanj-number-slider-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", max: "max", min: "min", step: "step", decimalPlaces: "decimalPlaces", tickInterval: "tickInterval", vertical: "vertical" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input-container" layout="column" layout-align="start center">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-slider flex
                   [disabled]="disabled"
                   [(ngModel)]="value"
                   (change)="valueChange.emit(value)"
                   [max]="max"
                   [min]="min"
                   [step]="step"
                   [thumbLabel]="true"
                   [tickInterval]="tickInterval"
                   [vertical]="vertical">
        </mat-slider>
        <mat-form-field flex="15"
                            class="tanj-number-slider-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="number"
                 max="{{max}}"
                 [disabled]="disabled"
                 [step]="step"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="value"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
            `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxValidator, selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i5$1.MatSlider, selector: "mat-slider", inputs: ["disabled", "color", "tabIndex", "invert", "max", "min", "step", "thumbLabel", "tickInterval", "value", "displayWith", "valueText", "vertical"], outputs: ["change", "input", "valueChange"], exportAs: ["matSlider"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberSliderWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-number-slider-widget', template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input-container" layout="column" layout-align="start center">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-slider flex
                   [disabled]="disabled"
                   [(ngModel)]="value"
                   (change)="valueChange.emit(value)"
                   [max]="max"
                   [min]="min"
                   [step]="step"
                   [thumbLabel]="true"
                   [tickInterval]="tickInterval"
                   [vertical]="vertical">
        </mat-slider>
        <mat-form-field flex="15"
                            class="tanj-number-slider-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="number"
                 max="{{max}}"
                 [disabled]="disabled"
                 [step]="step"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="value"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
            `, providers: [TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], min: [{
                type: Input
            }], step: [{
                type: Input
            }], decimalPlaces: [{
                type: Input
            }], tickInterval: [{
                type: Input
            }], vertical: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_NUMBER_SLIDER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => NumberSliderWidgetConfigureComponent),
    multi: true
};
class NumberSliderWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class NumberSliderWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'below';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 10;
        this.min = 0;
        this.step = 1;
        this.decimalPlaces = 0;
        this.labelChange = new EventEmitter(false);
        this.defaultValueChange = new EventEmitter(false);
        this.maxChange = new EventEmitter(false);
        this.minChange = new EventEmitter(false);
        this.stepChange = new EventEmitter(false);
        this.decimalPlacesChange = new EventEmitter(false);
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    emitChangeEvent(value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new NumberSliderWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
NumberSliderWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberSliderWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
NumberSliderWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: NumberSliderWidgetConfigureComponent, selector: "tanj-number-slider-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", max: "max", min: "min", step: "step", decimalPlaces: "decimalPlaces" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", maxChange: "maxChange", minChange: "minChange", stepChange: "stepChange", decimalPlacesChange: "decimalPlacesChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_NUMBER_SLIDER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-number-slider-widget [(value)]="defaultValue"
                                (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                                [defaultValue]="defaultValue"
                                [max]="max"
                                [min]="min"
                                [step]="step"
                                [decimalPlaces]="decimalPlaces"
                                label="Default Value"></tanj-number-slider-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Min"
               (change)="minChange.emit(min)"
               [(ngModel)]="min"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Step"
               (change)="stepChange.emit(step)"
               [(ngModel)]="step"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput class="tanj-input"
               type="number"
               placeholder="Decimal Places"
               (change)="decimalPlacesChange.emit(decimalPlaces)"
               [(ngModel)]="decimalPlaces"/>
      </mat-form-field>
    </ng-container>

  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: NumberSliderWidgetComponent, selector: "tanj-number-slider-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue", "max", "min", "step", "decimalPlaces", "tickInterval", "vertical"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberSliderWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-number-slider-configure',
                    template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-number-slider-widget [(value)]="defaultValue"
                                (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                                [defaultValue]="defaultValue"
                                [max]="max"
                                [min]="min"
                                [step]="step"
                                [decimalPlaces]="decimalPlaces"
                                label="Default Value"></tanj-number-slider-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Min"
               (change)="minChange.emit(min)"
               [(ngModel)]="min"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Step"
               (change)="stepChange.emit(step)"
               [(ngModel)]="step"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput class="tanj-input"
               type="number"
               placeholder="Decimal Places"
               (change)="decimalPlacesChange.emit(decimalPlaces)"
               [(ngModel)]="decimalPlaces"/>
      </mat-form-field>
    </ng-container>

  </div>
                 `,
                    providers: [TANJ_NUMBER_SLIDER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], min: [{
                type: Input
            }], step: [{
                type: Input
            }], decimalPlaces: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValueChange: [{
                type: Output
            }], maxChange: [{
                type: Output
            }], minChange: [{
                type: Output
            }], stepChange: [{
                type: Output
            }], decimalPlacesChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_NUMBER_SPINNER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => NumberSpinnerWidgetConfigureComponent),
    multi: true
};
class NumberSpinnerWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class NumberSpinnerWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 10;
        this.min = 0;
        this.step = 1;
        this.labelChange = new EventEmitter(false);
        this.defaultValueChange = new EventEmitter(false);
        this.decimalChange = new EventEmitter(false);
        this.maxChange = new EventEmitter(false);
        this.minChange = new EventEmitter(false);
        this.stepChange = new EventEmitter(false);
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => {
        };
        this.controlValueAccessorChangeFn = (value) => {
        };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    emitChangeEvent(value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new NumberSpinnerWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
NumberSpinnerWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberSpinnerWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
NumberSpinnerWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: NumberSpinnerWidgetConfigureComponent, selector: "tanj-number-spinner-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", max: "max", min: "min", step: "step" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", decimalChange: "decimalChange", maxChange: "maxChange", minChange: "minChange", stepChange: "stepChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_NUMBER_SPINNER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-number-spinner-widget [(value)]="defaultValue"
                                 (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                                 [defaultValue]="defaultValue"
                                 [max]="max"
                                 [min]="min"
                                 [step]="step"
                                 label="Default Value"></tanj-number-spinner-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Min"
               (change)="minChange.emit(min)"
               [(ngModel)]="min"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Step"
               (change)="stepChange.emit(step)"
               [(ngModel)]="step"/>
      </mat-form-field>
    </ng-container>

  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: NumberSpinnerWidgetComponent, selector: "tanj-number-spinner-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue", "max", "min", "step"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberSpinnerWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-number-spinner-configure',
                    template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-number-spinner-widget [(value)]="defaultValue"
                                 (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                                 [defaultValue]="defaultValue"
                                 [max]="max"
                                 [min]="min"
                                 [step]="step"
                                 label="Default Value"></tanj-number-spinner-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Min"
               (change)="minChange.emit(min)"
               [(ngModel)]="min"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Step"
               (change)="stepChange.emit(step)"
               [(ngModel)]="step"/>
      </mat-form-field>
    </ng-container>

  </div>
                 `,
                    providers: [TANJ_NUMBER_SPINNER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], min: [{
                type: Input
            }], step: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValueChange: [{
                type: Output
            }], decimalChange: [{
                type: Output
            }], maxChange: [{
                type: Output
            }], minChange: [{
                type: Output
            }], stepChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_NUMBER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => NumberWidgetComponent),
    multi: true
};
class NumberWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class NumberWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.min = 0;
        this.step = 1;
        this.decimalPlaces = 1;
        this.tickInterval = 10;
        this.vertical = false;
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new NumberWidgetChange(this, this.value));
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
NumberWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
NumberWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: NumberWidgetComponent, selector: "tanj-number-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", max: "max", min: "min", step: "step", decimalPlaces: "decimalPlaces", tickInterval: "tickInterval", vertical: "vertical" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_NUMBER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center">
    <span *ngIf="!hideLabel && labelPosition == 'before'" class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="center start">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-form-field flex
                            class="tanj-number-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="number"
                 max="{{max}}"
                 [disabled]="disabled"
                 [step]="step"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="value"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxValidator, selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-number-widget',
                    template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center">
    <span *ngIf="!hideLabel && labelPosition == 'before'" class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="center start">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-form-field flex
                            class="tanj-number-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="number"
                 max="{{max}}"
                 [disabled]="disabled"
                 [step]="step"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="value"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
                 `,
                    providers: [TANJ_NUMBER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], min: [{
                type: Input
            }], step: [{
                type: Input
            }], decimalPlaces: [{
                type: Input
            }], tickInterval: [{
                type: Input
            }], vertical: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_NUMBER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => NumberWidgetConfigureComponent),
    multi: true
};
class NumberWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class NumberWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 10;
        this.min = 0;
        this.step = 1;
        this.decimalPlaces = 0;
        this.labelChange = new EventEmitter(false);
        this.defaultValueChange = new EventEmitter(false);
        this.maxChange = new EventEmitter(false);
        this.minChange = new EventEmitter(false);
        this.stepChange = new EventEmitter(false);
        this.decimalPlacesChange = new EventEmitter(false);
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    emitChangeEvent(value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new NumberWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
NumberWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
NumberWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: NumberWidgetConfigureComponent, selector: "tanj-number-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", max: "max", min: "min", step: "step", decimalPlaces: "decimalPlaces" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", maxChange: "maxChange", minChange: "minChange", stepChange: "stepChange", decimalPlacesChange: "decimalPlacesChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_NUMBER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-number-widget [(value)]="defaultValue"
                         (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                         [defaultValue]="defaultValue"
                         [max]="max"
                         [min]="min"
                         [step]="step"
                         [decimalPlaces]="decimalPlaces"
                         label="Default Value"></tanj-number-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Min"
               (change)="minChange.emit(min)"
               [(ngModel)]="min"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Step"
               (change)="stepChange.emit(step)"
               [(ngModel)]="step"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput class="tanj-input"
               type="number"
               placeholder="Decimal Places"
               (change)="decimalPlacesChange.emit(decimalPlaces)"
               [(ngModel)]="decimalPlaces"/>
      </mat-form-field>
    </ng-container>

  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: NumberWidgetComponent, selector: "tanj-number-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue", "max", "min", "step", "decimalPlaces", "tickInterval", "vertical"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: NumberWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-number-configure',
                    template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-number-widget [(value)]="defaultValue"
                         (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                         [defaultValue]="defaultValue"
                         [max]="max"
                         [min]="min"
                         [step]="step"
                         [decimalPlaces]="decimalPlaces"
                         label="Default Value"></tanj-number-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Min"
               (change)="minChange.emit(min)"
               [(ngModel)]="min"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max"
               (change)="maxChange.emit(max)"
               [(ngModel)]="max"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Step"
               (change)="stepChange.emit(step)"
               [(ngModel)]="step"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput class="tanj-input"
               type="number"
               placeholder="Decimal Places"
               (change)="decimalPlacesChange.emit(decimalPlaces)"
               [(ngModel)]="decimalPlaces"/>
      </mat-form-field>
    </ng-container>

  </div>
                 `,
                    providers: [TANJ_NUMBER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], max: [{
                type: Input
            }], min: [{
                type: Input
            }], step: [{
                type: Input
            }], decimalPlaces: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValueChange: [{
                type: Output
            }], maxChange: [{
                type: Output
            }], minChange: [{
                type: Output
            }], stepChange: [{
                type: Output
            }], decimalPlacesChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_SLIDE_TOGGLE_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => SlideToggleWidgetComponent),
    multi: true
};
class SlideToggleWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class SlideToggleWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = false;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = false;
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new SlideToggleWidgetChange(this, this.value));
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
SlideToggleWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: SlideToggleWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
SlideToggleWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: SlideToggleWidgetComponent, selector: "tanj-slide-toggle-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_SLIDE_TOGGLE_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-slide-toggle-widget-label">{{label}}</span>
    <div flex layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-widget-input"
           layout="column"
           layout-align="start">
        <mat-slide-toggle flex
                         [disabled]="disabled"
                         [(ngModel)]="value"
                         (change)="handleValueChange(value)">
        </mat-slide-toggle>
      </div>
      <div *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</div>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-slide-toggle-widget-label">{{label}}</span>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i5.MatSlideToggle, selector: "mat-slide-toggle", inputs: ["disabled", "disableRipple", "color", "tabIndex"], exportAs: ["matSlideToggle"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: SlideToggleWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-slide-toggle-widget',
                    template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-slide-toggle-widget-label">{{label}}</span>
    <div flex layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-widget-input"
           layout="column"
           layout-align="start">
        <mat-slide-toggle flex
                         [disabled]="disabled"
                         [(ngModel)]="value"
                         (change)="handleValueChange(value)">
        </mat-slide-toggle>
      </div>
      <div *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</div>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-slide-toggle-widget-label">{{label}}</span>
  </div>
                 `,
                    providers: [TANJ_SLIDE_TOGGLE_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows IconRatingWidget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_SLIDE_TOGGLE_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => SlideToggleWidgetConfigureComponent),
    multi: true
};
class SlideToggleWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class SlideToggleWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = false;
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = false;
        this.labelChange = new EventEmitter(false);
        this.defaultValueChange = new EventEmitter(false);
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    emitChangeEvent(value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new SlideToggleWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
SlideToggleWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: SlideToggleWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
SlideToggleWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: SlideToggleWidgetConfigureComponent, selector: "tanj-slide-toggle-widget-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_SLIDE_TOGGLE_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="emitChangeEvent(false, true)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-slide-toggle-widget [(value)]="defaultValue"
                               (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                               [defaultValue]="defaultValue"
                               label="Default Value"
                               [labelPosition]="'before'">

      </tanj-slide-toggle-widget>
    </ng-container>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: SlideToggleWidgetComponent, selector: "tanj-slide-toggle-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: SlideToggleWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-slide-toggle-widget-configure',
                    template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="emitChangeEvent(false, true)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-slide-toggle-widget [(value)]="defaultValue"
                               (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                               [defaultValue]="defaultValue"
                               label="Default Value"
                               [labelPosition]="'before'">

      </tanj-slide-toggle-widget>
    </ng-container>
  </div>
                 `,
                    providers: [TANJ_SLIDE_TOGGLE_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValueChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_TEXT_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => TextWidgetComponent),
    multi: true
};
class TextWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class TextWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = '';
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = '';
        this.maxLength = 100;
        this.minLength = 0;
        /* end Configuration Fields */
        this.change = new EventEmitter(false);
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => {
        };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new TextWidgetChange(this, this.value));
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
TextWidgetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: TextWidgetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
TextWidgetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: TextWidgetComponent, selector: "tanj-text-widget", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", maxLength: "maxLength", minLength: "minLength" }, outputs: { valueChange: "valueChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_TEXT_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center">
    <span *ngIf="!hideLabel && labelPosition == 'before'" class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="center start">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-form-field flex
                            class="tanj-text-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="text"
                 minlength="{{minLength}}"
                 maxlength="{{maxLength}}"
                 [disabled]="disabled"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="value"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: TextWidgetComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-text-widget',
                    template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="start center">
    <span *ngIf="!hideLabel && labelPosition == 'before'" class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="center start">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-form-field flex
                            class="tanj-text-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="text"
                 minlength="{{minLength}}"
                 maxlength="{{maxLength}}"
                 [disabled]="disabled"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="value"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
                 `,
                    providers: [TANJ_TEXT_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], hideLabel: [{
                type: Input
            }], onlyLabel: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], maxLength: [{
                type: Input
            }], minLength: [{
                type: Input
            }], change: [{
                type: Output
            }] } });

/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
const TANJ_TEXT_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => TextWidgetConfigureComponent),
    multi: true
};
class TextWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
class TextWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = '';
        this.valueChange = new EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = '';
        this.maxLength = 100;
        this.minLength = 0;
        this.labelChange = new EventEmitter(false);
        this.defaultValueChange = new EventEmitter(false);
        this.maxLengthChange = new EventEmitter(false);
        this.minLengthChange = new EventEmitter(false);
        this.change = new EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    emitChangeEvent(value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new TextWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
TextWidgetConfigureComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: TextWidgetConfigureComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
TextWidgetConfigureComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.10", type: TextWidgetConfigureComponent, selector: "tanj-text-configure", inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", maxLength: "maxLength", minLength: "minLength" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", maxLengthChange: "maxLengthChange", minLengthChange: "minLengthChange", change: "change" }, host: { properties: { "attr.flex": "this.flex", "attr.layout": "this.flexLayout", "attr.layout-align": "this.flexLayoutAlign" } }, providers: [TANJ_TEXT_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR], usesOnChanges: true, ngImport: i0, template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-text-widget [(value)]="defaultValue"
                       (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                       [defaultValue]="defaultValue"
                       [maxLength]="maxLength"
                       [minLength]="minLength"
                       label="Default Value"></tanj-text-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Min Length"
               (change)="minLengthChange.emit(minLength)"
               [(ngModel)]="minLength"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max Length"
               (change)="maxLengthChange.emit(maxLength)"
               [(ngModel)]="maxLength"/>
      </mat-form-field>
    </ng-container>

  </div>
                 `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i3$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: TextWidgetComponent, selector: "tanj-text-widget", inputs: ["value", "labelPosition", "disabled", "hideLabel", "onlyLabel", "label", "defaultValue", "maxLength", "minLength"], outputs: ["valueChange", "change"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: TextWidgetConfigureComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'tanj-text-configure',
                    template: `<!-- -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput class="tanj-input" type="text" maxlength="50" placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>
    <ng-container *ngIf="label">
      <tanj-text-widget [(value)]="defaultValue"
                       (valueChange)="value = defaultValue; emitChangeEvent(true, false)"
                       [defaultValue]="defaultValue"
                       [maxLength]="maxLength"
                       [minLength]="minLength"
                       label="Default Value"></tanj-text-widget>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Min Length"
               (change)="minLengthChange.emit(minLength)"
               [(ngModel)]="minLength"/>
      </mat-form-field>
      <mat-form-field dividerColor="accent">
        <input matInput
               class="tanj-input"
               type="number"
               placeholder="Max Length"
               (change)="maxLengthChange.emit(maxLength)"
               [(ngModel)]="maxLength"/>
      </mat-form-field>
    </ng-container>

  </div>
                 `,
                    providers: [TANJ_TEXT_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                    encapsulation: ViewEncapsulation.None
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { flex: [{
                type: HostBinding,
                args: ['attr.flex']
            }], flexLayout: [{
                type: HostBinding,
                args: ['attr.layout']
            }], flexLayoutAlign: [{
                type: HostBinding,
                args: ['attr.layout-align']
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], labelPosition: [{
                type: Input
            }], disabled: [{
                type: Input
            }], label: [{
                type: Input
            }], defaultValue: [{
                type: Input
            }], maxLength: [{
                type: Input
            }], minLength: [{
                type: Input
            }], labelChange: [{
                type: Output
            }], defaultValueChange: [{
                type: Output
            }], maxLengthChange: [{
                type: Output
            }], minLengthChange: [{
                type: Output
            }], change: [{
                type: Output
            }] } });

class TanjInputWidgetModule {
}
TanjInputWidgetModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: TanjInputWidgetModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
TanjInputWidgetModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.10", ngImport: i0, type: TanjInputWidgetModule, declarations: [CheckboxWidgetComponent,
        CheckboxWidgetConfigureComponent,
        DateTimeWidgetComponent,
        DateTimeWidgetConfigureComponent,
        DurationPickerDialog,
        DurationPickerWidgetComponent,
        DurationPickerWidgetConfigureComponent,
        IconRatingWidgetComponent,
        IconRatingWidgetConfigureComponent,
        NumberWidgetComponent,
        NumberWidgetConfigureComponent,
        NumberSliderWidgetComponent,
        NumberSliderWidgetConfigureComponent,
        NumberSpinnerWidgetComponent,
        NumberSpinnerWidgetConfigureComponent,
        SlideToggleWidgetComponent,
        SlideToggleWidgetConfigureComponent,
        TextWidgetComponent,
        TextWidgetConfigureComponent], imports: [CommonModule,
        FormsModule,
        MatInputModule,
        MatCheckboxModule,
        MatSlideToggleModule,
        MatSliderModule,
        MatFormFieldModule,
        TanjComponentsModule], exports: [CheckboxWidgetComponent,
        CheckboxWidgetConfigureComponent,
        DateTimeWidgetComponent,
        DateTimeWidgetConfigureComponent,
        DurationPickerDialog,
        DurationPickerWidgetComponent,
        DurationPickerWidgetConfigureComponent,
        IconRatingWidgetComponent,
        IconRatingWidgetConfigureComponent,
        NumberSliderWidgetComponent,
        NumberSliderWidgetConfigureComponent,
        NumberSpinnerWidgetComponent,
        NumberSpinnerWidgetConfigureComponent,
        NumberWidgetComponent,
        NumberWidgetConfigureComponent,
        SlideToggleWidgetComponent,
        SlideToggleWidgetConfigureComponent,
        TextWidgetComponent,
        TextWidgetConfigureComponent] });
TanjInputWidgetModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: TanjInputWidgetModule, imports: [CommonModule,
        FormsModule,
        MatInputModule,
        MatCheckboxModule,
        MatSlideToggleModule,
        MatSliderModule,
        MatFormFieldModule,
        TanjComponentsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.10", ngImport: i0, type: TanjInputWidgetModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        MatInputModule,
                        MatCheckboxModule,
                        MatSlideToggleModule,
                        MatSliderModule,
                        MatFormFieldModule,
                        TanjComponentsModule
                    ],
                    declarations: [
                        CheckboxWidgetComponent,
                        CheckboxWidgetConfigureComponent,
                        DateTimeWidgetComponent,
                        DateTimeWidgetConfigureComponent,
                        DurationPickerDialog,
                        DurationPickerWidgetComponent,
                        DurationPickerWidgetConfigureComponent,
                        IconRatingWidgetComponent,
                        IconRatingWidgetConfigureComponent,
                        NumberWidgetComponent,
                        NumberWidgetConfigureComponent,
                        NumberSliderWidgetComponent,
                        NumberSliderWidgetConfigureComponent,
                        NumberSpinnerWidgetComponent,
                        NumberSpinnerWidgetConfigureComponent,
                        SlideToggleWidgetComponent,
                        SlideToggleWidgetConfigureComponent,
                        TextWidgetComponent,
                        TextWidgetConfigureComponent,
                    ],
                    exports: [
                        CheckboxWidgetComponent,
                        CheckboxWidgetConfigureComponent,
                        DateTimeWidgetComponent,
                        DateTimeWidgetConfigureComponent,
                        DurationPickerDialog,
                        DurationPickerWidgetComponent,
                        DurationPickerWidgetConfigureComponent,
                        IconRatingWidgetComponent,
                        IconRatingWidgetConfigureComponent,
                        NumberSliderWidgetComponent,
                        NumberSliderWidgetConfigureComponent,
                        NumberSpinnerWidgetComponent,
                        NumberSpinnerWidgetConfigureComponent,
                        NumberWidgetComponent,
                        NumberWidgetConfigureComponent,
                        SlideToggleWidgetComponent,
                        SlideToggleWidgetConfigureComponent,
                        TextWidgetComponent,
                        TextWidgetConfigureComponent,
                    ],
                    entryComponents: [
                        DurationPickerDialog,
                    ]
                }]
        }] });

/*
 * Public API Surface of input-widgets
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CheckboxWidgetChange, CheckboxWidgetComponent, CheckboxWidgetConfigureChange, CheckboxWidgetConfigureComponent, DateTimeWidgetChange, DateTimeWidgetComponent, DateTimeWidgetConfigureChange, DateTimeWidgetConfigureComponent, DurationPickerDialog, DurationPickerDialogResult, DurationPickerFieldsState, DurationPickerState, DurationPickerWidgetChange, DurationPickerWidgetComponent, DurationPickerWidgetConfigureChange, DurationPickerWidgetConfigureComponent, IconRatingWidgetChange, IconRatingWidgetComponent, IconRatingWidgetConfigureChange, IconRatingWidgetConfigureComponent, NumberSliderWidgetChange, NumberSliderWidgetComponent, NumberSliderWidgetConfigureChange, NumberSliderWidgetConfigureComponent, NumberSpinnerWidgetChange, NumberSpinnerWidgetComponent, NumberSpinnerWidgetConfigureChange, NumberSpinnerWidgetConfigureComponent, NumberWidgetChange, NumberWidgetComponent, NumberWidgetConfigureChange, NumberWidgetConfigureComponent, SlideToggleWidgetChange, SlideToggleWidgetComponent, SlideToggleWidgetConfigureChange, SlideToggleWidgetConfigureComponent, TANJ_CHECKBOX_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_CHECKBOX_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TANJ_DATE_TIME_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_DATE_TIME_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TANJ_NUMBER_SLIDER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TANJ_NUMBER_SPINNER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_NUMBER_SPINNER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TANJ_NUMBER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_NUMBER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TANJ_SLIDE_TOGGLE_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_SLIDE_TOGGLE_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TANJ_TEXT_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR, TANJ_TEXT_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR, TanjInputWidgetModule, TextWidgetChange, TextWidgetComponent, TextWidgetConfigureChange, TextWidgetConfigureComponent };
//# sourceMappingURL=tangential-input-widgets.mjs.map
