import { ChangeDetectorRef, EventEmitter, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
export declare const TANJ_CHECKBOX_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR: any;
export declare class CheckboxWidgetConfigureChange {
    source: CheckboxWidgetConfigureComponent;
    value: boolean;
    constructor(source: CheckboxWidgetConfigureComponent, value: boolean);
}
export declare class CheckboxWidgetConfigureComponent implements OnInit, ControlValueAccessor {
    private changeDetectorRef;
    flex: string;
    flexLayout: string;
    flexLayoutAlign: string;
    value: boolean;
    valueChange: EventEmitter<boolean>;
    labelPosition: 'before' | 'after' | 'below';
    disabled: boolean;
    /**
     * Configuration Fields
     */
    label: string;
    labelChange: EventEmitter<string>;
    defaultValue: boolean;
    defaultValueChange: EventEmitter<boolean>;
    change: EventEmitter<any>;
    /**
     * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
     * @docs-private
     */
    onTouched: () => any;
    private controlValueAccessorChangeFn;
    constructor(changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    emitChangeEvent(value: boolean, label: boolean): void;
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value: boolean): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CheckboxWidgetConfigureComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CheckboxWidgetConfigureComponent, "tanj-checkbox-widget-configure", never, { "value": "value"; "labelPosition": "labelPosition"; "disabled": "disabled"; "label": "label"; "defaultValue": "defaultValue"; }, { "valueChange": "valueChange"; "labelChange": "labelChange"; "defaultValueChange": "defaultValueChange"; "change": "change"; }, never, never, false>;
}
